<?php 
/************************************************************
Program		Slashorg Downloader
Filename		include/inc_functions.php
Version		0.96
Last update	03/01/2006

Send bug reports to dev@slashorg.net
************************************************************/

function send_file($path, $ThrottleSpeed) {

	// Definitions...
        $wait = 0;

	// Speed limitation
	if ($ThrottleSpeed) {
		$wait = 1000000*(8/$ThrottleSpeed);
	}

	@ob_end_clean(); 
	@ini_set('zlib.output_compression', 'Off');

	header('Pragma: public');
	header('Expires: 0');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Cache-Control: public'); 
	header('Content-Type: application/force-download');
	header('Content-Type: application/octet-stream');
	header('Content-Type: application/download');
	header('Content-Disposition: attachment; filename="' . basename($path) . '";');
	header('Content-Transfer-Encoding: binary');
	header('Content-Length: ' . filesize($path));

	$handle = fopen($path, 'rb');

	do {
		$data = fread($handle, 8192);
		if (strlen($data) == 0) {
			break;
		}
		echo($data);

		// Wait some microseconds to slow down transfer speed.
		usleep ($wait);

	} while (true);

	fclose($handle);
	exit();
}

function display_nav($p, $UploadDir) {
	$p_explode = explode('/', $p);
	$i = 0;
	$url = NULL;
	$nav = $lang['location'].' <a href="./">Home</a> ';
	for($i ; $i < count($p_explode) - 1 ; $i++) {
		$url .= urlencode($p_explode[$i]).'/';
		$nav .= '> <a href="./?p='.$url.'">'.htmlspecialchars($p_explode[$i], ENT_NOQUOTES).'</a> ';
	}

	if (is_file($UploadDir . $p))
		$nav .= '> <a href="?p='.urlencode($p).'">'.htmlspecialchars($p_explode[$i], ENT_NOQUOTES).'</a> ';

	return($nav);
}

function erase_stuff($name) {
	if (is_file($name)) {
		if (@unlink($name))
			$return = true;
		else
			return (false);
	}

	if (is_dir($name)) {
		$dir = dir($name);
		while($entry = $dir->read()) {
			if ($entry != '.' && $entry != '..') {
				if(is_dir($name . '/' . $entry))
					$return = erase_stuff($name . '/' . $entry);
				else
					if (@unlink($name . '/' . $entry))
						$return = true;
					else
						return (false);
			}
		}
		$dir->close();
		if (@rmdir($name))
			$return = true;
		else
			return (false);
	}
	return ($return);
}

function check_root_dir($dir, $p) {
	$root_dir = str_replace('/', '\/', $dir);

	if (!preg_match("/^$root_dir/", $p))
		$p = $dir;

	return ($p);
}
?>
